
#include <cstring>

static inline void mm_empty() {}

typedef int v8qi __attribute__ ((mode(V8QI)));
typedef long long unsigned int ullint;
struct v8byte {
  v8qi d;
  v8byte() {}
  v8byte(v8qi d0) : d(d0) {}
  v8byte(ullint d0) : d((v8qi)d0) {}
  inline v8byte & zero() {
    d = (v8qi)__builtin_ia32_pxor((ullint)d,(ullint)d); return *this;}
  inline v8byte & ones() {
    d = (v8qi)__builtin_ia32_pcmpeqb(d,d); return *this;}
  inline v8byte & set(unsigned char b) {
    std::memset(&d,b,8); return *this;}
  inline v8byte & operator+= (v8byte y) {
    d = __builtin_ia32_paddb(d,y.d); return *this;}
  inline v8byte & operator-= (v8byte y) {
    d = __builtin_ia32_psubb(d,y.d); return *this;}
};
struct v8ubyte : public v8byte 
{
  v8ubyte() {}
  v8ubyte(v8qi d0) : v8byte(d0) {}
  v8ubyte(v8byte v0) : v8byte(v0) {}
};
struct v8sbyte : public v8byte 
{
  v8sbyte() {}
  v8sbyte(v8qi d0) : v8byte(d0) {}
  v8sbyte(v8byte v0) : v8byte(v0) {}
};

static inline v8ubyte min(v8ubyte x, v8ubyte y) {
  return __builtin_ia32_pminub(x.d,y.d);}
static inline v8ubyte max(v8ubyte x, v8ubyte y) {
  return __builtin_ia32_pmaxub(x.d,y.d);}
static inline v8ubyte avg(v8ubyte x, v8ubyte y) {
  return __builtin_ia32_pavgb(x.d,y.d);}

static inline v8byte operator+ (v8byte x, v8byte y) {
  return __builtin_ia32_paddb(x.d,y.d);}
static inline v8byte operator- (v8byte x, v8byte y) {
  return __builtin_ia32_psubb(x.d,y.d);}

static inline v8byte sadd (v8ubyte x, v8ubyte y) {
  return __builtin_ia32_paddusb(x.d,y.d);}
static inline v8byte ssub (v8ubyte x, v8ubyte y) {
  return __builtin_ia32_psubusb(x.d,y.d);}

static inline v8byte operator== (v8byte x, v8byte y) {
  return __builtin_ia32_pcmpeqb(x.d,y.d);}

static inline v8sbyte operator> (v8sbyte x, v8sbyte y) {
  return __builtin_ia32_pcmpgtb(x.d,y.d);}
static inline v8sbyte operator< (v8sbyte x, v8sbyte y) {
  return y > x;}

static inline v8byte operator& (v8byte x, v8byte y) {
  return __builtin_ia32_pand((ullint)x.d,(ullint)y.d);}
static inline v8byte andn (v8byte x, v8byte y) {
  return __builtin_ia32_pandn((ullint)x.d,(ullint)y.d);}
static inline v8byte operator| (v8byte x, v8byte y) {
  return __builtin_ia32_por((ullint)x.d,(ullint)y.d);}
static inline v8byte operator^ (v8byte x, v8byte y) {
  return __builtin_ia32_pxor((ullint)x.d,(ullint)y.d);}

static inline v8ubyte operator>= (v8ubyte x, v8ubyte y) {
  return min(x,y) == y;}
static inline v8ubyte operator<= (v8ubyte x, v8ubyte y) {
  return max(x,y) == y;}

static inline v8ubyte dist(v8ubyte x, v8ubyte y) {
  return ssub(x,y) | ssub(y,x);}

static inline v8byte if_else(v8byte p, v8byte x, v8byte y) {
  return (x & p) | andn(p,y);}

static inline v8sbyte operator-(v8sbyte x) {
  return v8byte().zero() - x;}
